import 'dart:async';

import 'package:flutter/widgets.dart';

import '../mvc.dart';
import 'Model.dart';

// ignore: must_be_immutable
abstract class Controller<V extends View, M extends Model>
    extends StatefulWidget {
  // ignore: close_sinks
  StreamController<Event> streamController;
  V view;
  M model;
  BuildContext context;

  void create(View view, Model model) {
    streamController = StreamController();
    this.model = model;
    this.view = view;
    view.addNotifier(streamController);

    streamController.stream.listen(eventHandler);
  }

  void eventHandler(Event event);
}