import 'package:flutter/widgets.dart';

import '../mvc.dart';

abstract class ControllerState<ExtendedController extends Controller>
    extends State<ExtendedController> {
  @override
  Widget build(BuildContext context) {
    return widget.view.viewWidget;
  }

  @override
  void initState() {
    super.initState();

    widget.context = context;
  }

  @override
  void didUpdateWidget(ExtendedController oldWidget) {
    super.didUpdateWidget(oldWidget);

    widget.context = oldWidget.context;
  }

  @override
  void dispose() {
    widget.streamController.close();
    widget.context = null;

    super.dispose();
  }
}
